' Fig. C.01: Account.vb
' Account class with a constructor to initialize a customer's balance.
Public Class Account
   ' instance variable that stores the balance
   Private balanceValue As Integer

   ' constructor
   Public Sub New(ByVal initialBalance As Integer)
      ' if initialBalance is not greater than 0,
      ' balance is still initialized to 0 by default
      If initialBalance > 0 Then
         Balance = initialBalance
      End If
   End Sub ' New

   ' credits (increases) the account by amount
   Public Sub Credit(ByVal amount As Integer)
      Balance = Balance + amount ' add amount to balance
   End Sub ' Credit

   ' debits (decreases) the account by amount
   Public Sub Debit(ByVal amount As Integer)
      If amount > Balance Then
         Console.WriteLine("Debit amount exceeded account balance.")
      End If

      If amount <= Balance Then
         Balance = Balance - amount ' subtract amount to balance
      End If
   End Sub ' Debit

   ' property makes balanceValue available to clients;
   ' no validation required
   Public Property Balance() As Integer
      Get ' returns the account balance
         Return balanceValue
      End Get

      Set(ByVal value As Integer) ' sets the balance value
         balanceValue = value
      End Set
   End Property ' Balance
End Class ' Account

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************