' Fig. 7.12: Scope.vb
' Scope class demonstrates instance and local variable scopes.
Public Class Scope
   ' instance variable that is accessible to all methods of this class
   Private x As Integer = 1

   ' method Begin creates and initializes local variable x and
   ' calls methods UseLocalVariable and UseInstanceVariable
   Public Sub Begin()
      ' method's local variable x shadows instance variable x
      Dim x As Integer = 5

      Console.WriteLine("local x in method Begin is " & x)

      UseLocalVariable() ' UseLocalVariable has local x
      UseInstanceVariable() ' uses class Scope's instance variable x
      UseLocalVariable() ' UseLocalVariable reinitializes local x
      UseInstanceVariable() ' Scope's instance variable x retains value

      Console.WriteLine(vbCrLf & "local x in method Begin is " & x)
   End Sub ' Begin

   ' create and initialize local variable x during each call
   Sub UseLocalVariable()
      Dim x As Integer = 25 ' initialized in each call

      Console.WriteLine( _
         vbCrLf & "local x on entering method UseLocalVariable is " & x)
      x += 1 ' modifies this method's local variable x
      Console.WriteLine("local variable x before exiting method " & _
         "UseLocalVariable is " & x)
   End Sub ' UseLocalVariable

   ' modify class Scope's instance variable x during each call
   Sub UseInstanceVariable()
      Console.WriteLine(vbCrLf & "instance variable" & _
         " x on entering method UseInstanceVariable is " & x)
      x *= 10 ' modifies class Scope's instance variable x
      Console.WriteLine("instance variable " & _
         "x before exiting method UseInstanceVariable is " & x)
   End Sub ' UseInstanceVariable
End Class ' Scope


' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************