﻿' Fig 7.18: CrapsGame.vb
' Playing a craps game.
Imports System.IO

Public Class FrmCrapsGame
   ' die-roll constants
   Enum DiceNames
      SNAKE_EYES = 2
      TREY = 3
      LUCKY_SEVEN = 7
      CRAPS = 7
      YO_LEVEN = 11
      BOX_CARS = 12
   End Enum

   ' file-name and directory constants
   Const FILE_PREFIX As String = "/images/die"
   Const FILE_SUFFIX As String = ".png"

   Dim myPoint As Integer ' total point
   Dim myDie1 As Integer ' die1 face
   Dim myDie2 As Integer ' die2 face
   Dim randomObject As New Random() ' generate random number

   ' begins new game and determines point
   Private Sub btnPlay_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnPlay.Click

      ' initialize variables for new game
      myPoint = 0
      grpPoint.Text = "Point"
      lblStatus.Text = ""

      ' remove point-die images
      picPointDie1.Image = Nothing
      picPointDie2.Image = Nothing

      Dim sum As Integer = RollDice() ' roll dice and calculate sum

      ' check die roll
      Select Case sum
         Case DiceNames.LUCKY_SEVEN, DiceNames.YO_LEVEN
            btnRoll.Enabled = False ' disable Roll button
            lblStatus.Text = "You Win!!!"
         Case DiceNames.SNAKE_EYES, DiceNames.TREY, DiceNames.BOX_CARS
            btnRoll.Enabled = False ' disable Roll button
            lblStatus.Text = "Sorry. You Lose."
         Case Else
            myPoint = sum
            grpPoint.Text = "Point is " & sum
            lblStatus.Text = "Roll Again!"
            DisplayDie(picPointDie1, myDie1)
            DisplayDie(picPointDie2, myDie2)
            btnPlay.Enabled = False ' disable Play button
            btnRoll.Enabled = True ' enable Roll button
      End Select
   End Sub ' btnPlay_Click

   ' determines outcome of next roll
   Private Sub btnRoll_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnRoll.Click

      Dim sum As Integer = RollDice() ' roll dice and calculate sum

      ' check outcome of roll
      If sum = myPoint Then ' win
         lblStatus.Text = "You Win!!!"
         btnRoll.Enabled = False ' disable Roll button
         btnPlay.Enabled = True ' enable Play button
      ElseIf sum = DiceNames.CRAPS Then ' lose
         lblStatus.Text = "Sorry. You Lose."
         btnRoll.Enabled = False ' disable Roll button
         btnPlay.Enabled = True ' enable Play button
      End If
   End Sub ' btnRoll_Click

   ' display die image
   Sub DisplayDie(ByVal picDie As PictureBox, _
      ByVal face As Integer)
      ' assign die image to picture box
      picDie.Image = Image.FromFile(Directory.GetCurrentDirectory & _
         FILE_PREFIX & face & FILE_SUFFIX)
   End Sub ' DisplayDie

   ' generate random die rolls
   Function RollDice() As Integer
      ' determine random integer
      myDie1 = randomObject.Next(1, 7)
      myDie2 = randomObject.Next(1, 7)

      ' display rolls
      DisplayDie(picDie1, myDie1)
      DisplayDie(picDie2, myDie2)

      Return myDie1 + myDie2 ' return sum
   End Function ' RollDice
End Class ' FrmCrapsGame

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************