' Fig 8.21: ReDimTest.vb
' Resize an array using the ReDim statement.
Module ReDimTest
   Sub Main()
      ' create and initialize a 5-element array
      Dim array As Integer() = {1, 2, 3, 4, 5}
      Dim arrayCopy As Integer() = array

      ' display array length and the elements in array
      Console.Write("The original array has {0} elements: ", _
         array.Length)
      DisplayArray(array)
      
      ' change the size of the array without the Preserve keyword
      ReDim array(6)

      ' display new array length and the elements in array
      Console.Write("New array (without Preserve) has {0} elements: ", _
         array.Length)
      DisplayArray(array)

      ' change the size of the array with the Preserve keyword
      ReDim Preserve arrayCopy(6)
      arrayCopy(6) = 7 ' assign 7 to array element 6        

      ' display new array length and the elements in array
      Console.Write("New array (with Preserve) has {0} elements: ", _
         arrayCopy.Length)
      DisplayArray(arrayCopy)
   End Sub ' Main

   ' display array elements
   Sub DisplayArray(ByVal array As Integer())
      For Each number As Integer In array
         Console.Write("{0} ", number)
      Next

      Console.WriteLine()
   End Sub ' DisplayArray
End Module ' ReDimTest

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************
