' Fig. 9.5: Day.vb
' Encapsulates month, day and year.
Class Day
   Private monthValue As Integer ' 1-12                    
   Private dayValue As Integer ' 1-31 based on month       
   Private yearValue As Integer ' any year (could validate)

   ' constructor confirms proper value for month, then calls
   ' method CheckDay to confirm proper value for day
   Public Sub New(ByVal mm As Integer, _
      ByVal dd As Integer, ByVal yy As Integer)
      Month = mm
      Day = dd
      Year = yy
   End Sub ' New

   ' property Month
   Public Property Month() As Integer
      Get
         Return monthValue
      End Get

      Set(ByVal mm As Integer)
         ' ensure month value is valid (in the range 1-12)
         If (mm > 0 AndAlso mm <= 12) Then
            monthValue = mm
         Else
            monthValue = 1 ' to ensure consistent state

            ' inform user of error
            Console.WriteLine("Invalid month (" & mm & _
               ") set to 1.")
         End If
      End Set
   End Property ' Month

   ' property Day
   Public Property Day() As Integer
      Get
         Return dayValue
      End Get

      Set(ByVal dd As Integer)
         dayValue = CheckDay(dd) ' validate dayPassed
      End Set
   End Property ' Day

   ' property Year
   Public Property Year() As Integer
      Get
         Return yearValue
      End Get

      Set(ByVal yy As Integer)
         yearValue = yy
      End Set
   End Property ' Year

   ' confirm proper day value based on month and year
   Private Function CheckDay(ByVal testDayValue As Integer) As Integer
      Dim daysPerMonth() As Integer = _
         {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}

      ' validate day
      If (testDayValue > 0 AndAlso _
         testDayValue <= daysPerMonth(Month)) Then
         Return testDayValue
      End If

      ' check for leap year in February                  
      If (Month = 2 AndAlso testDayValue = 29 AndAlso _
         ((Year Mod 400 = 0) OrElse _
         (Year Mod 4 = 0 AndAlso Year Mod 100 <> 0))) Then
         Return testDayValue
      End If

      ' inform user of error
      Console.WriteLine("Invalid day (" & testDayValue & ") set to 1. ")
      Return 1 ' leave object in consistent state
   End Function ' CheckDay

   ' create string containing month/day/year format
   Public Overrides Function ToString() As String
      Return (Month & "/" & Day & "/" & Year)
   End Function ' ToString
End Class ' Day



' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************