' Fig. 12.7: SquareRootTest.vb
' Demonstrating a user-defined exception class.
Public Class frmSquareRootTest
   ' computes square root of parameter; throws 
   ' NegativeNumberException if parameter is negative
   Public Function SquareRoot(ByVal value As Double) As Double
      ' if negative operand, throw NegativeNumberException
      If value < 0 Then
         Throw New NegativeNumberException( _
            "Square root of negative number not permitted")
      Else
         Return Math.Sqrt(value) ' compute square root
      End If
   End Function ' SquareRoot

   ' obtain user input, convert to double, calculate square root
   Private Sub btnSquareRoot_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnSquareRoot.Click

      lblOutput.Text = "" ' clear lblOutput

      ' catch any NegativeNumberException thrown
      Try
         Dim result As Double = _
            SquareRoot(Convert.ToDouble(txtInput.Text))

         lblOutput.Text = result.ToString()
      Catch formatExceptionParameter As FormatException
         MessageBox.Show(formatExceptionParameter.Message, _
            "Invalid Number Format", MessageBoxButtons.OK, _
            MessageBoxIcon.Error)
      Catch negativeNumberExceptionParameter As NegativeNumberException
         MessageBox.Show(negativeNumberExceptionParameter.Message, _
            "Invalid Operation", MessageBoxButtons.OK, _
            MessageBoxIcon.Error)
      End Try
   End Sub ' btnSquareRoot_Click
End Class ' frmSquareRootTest


'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************