' Fig. 14.23: FrmComboBoxTest.vb
' Using ComboBox to select a shape to draw.
Public Class FrmComboBoxTest
   ' get index of selected shape, then draw the shape
   Private Sub cboImage_SelectedIndexChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles cboImage.SelectedIndexChanged
      ' create graphics object, Pen and SolidBrush
      Dim myGraphics As Graphics = MyBase.CreateGraphics()

      ' create Pen using color DarkRed
      Dim myPen As Pen = New Pen(Color.DarkRed)

      ' create SolidBrush using color DarkRed
      Dim mySolidBrush As SolidBrush = New SolidBrush(Color.DarkRed)

      ' clear drawing area setting it to color white
      myGraphics.Clear(Color.White)

      ' find index, draw proper shape
      Select Case cboImage.SelectedIndex
         Case 0 ' case Circle is selected
            myGraphics.DrawEllipse(myPen, 50, 50, 150, 150)
         Case 1 ' case Rectangle is selected
            myGraphics.DrawRectangle(myPen, 50, 50, 150, 150)
         Case 2 ' case Ellipse is selected
            myGraphics.DrawEllipse(myPen, 50, 85, 150, 115)
         Case 3 ' case Pie is selected
            myGraphics.DrawPie(myPen, 50, 50, 150, 150, 0, 45)
         Case 4 ' case Filled Circle is selected
            myGraphics.FillEllipse(mySolidBrush, 50, 50, 150, 150)
         Case 5 ' case Filled Rectangle is selected
            myGraphics.FillRectangle(mySolidBrush, 50, 50, 150, 150)
         Case 6 ' case Filled Ellipse is selected
            myGraphics.FillEllipse(mySolidBrush, 50, 85, 150, 115)
         Case 7 ' case Filled Pie is selected
            myGraphics.FillPie(mySolidBrush, 50, 50, 150, 150, 0, 45)
      End Select

      myGraphics.Dispose() ' release the Graphics object  
   End Sub ' cboImage_SelectedIndexChanged
End Class ' FrmComboBoxTest


' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************

