' Fig. 15.7: UnsynchronizedBuffer.vb
' An unsynchronized shared buffer implementation.
Imports System.Threading

' this class represents a single shared Integer
Public Class UnsynchronizedBuffer
   Implements IBuffer

   ' buffer shared by producer and consumer threads
   Private bufferValue As Integer = -1

   ' property Buffer
   Public Property Buffer() As Integer Implements IBuffer.Buffer
      Get
         Console.WriteLine(Thread.CurrentThread.Name & _
            " reads " & bufferValue)
         Return bufferValue
      End Get
      Set(ByVal value As Integer)
         Console.WriteLine(Thread.CurrentThread.Name & _
            " writes " & value)
         bufferValue = value
      End Set
   End Property ' Buffer
End Class ' UnsynchronizedBuffer

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************