' Fig. 15.5: Producer.vb
' Producer produces ten integer values in the shared buffer.
Imports System.Threading

' class Producer's Produce method controls a thread that
' stores values from 1 to 10 in sharedLocation
Public Class Producer
   Private sharedLocation As IBuffer
   Private randomSleepTime As Random

   ' constructor
   Public Sub New(ByVal sharedBuffer As IBuffer, ByVal random As Random)
      sharedLocation = sharedBuffer
      randomSleepTime = random
   End Sub ' New

   ' store values 1-10 in object sharedLocation
   Public Sub Produce()
      ' sleep for random interval upto 3000 milliseconds
      ' then set sharedLocation's Buffer property
      For count As Integer = 1 To 10
         Thread.Sleep(randomSleepTime.Next(1, 3001))
         sharedLocation.Buffer = count
      Next count

      Console.WriteLine(Thread.CurrentThread.Name & " done producing." & _
         vbCrLf & "Terminating " & Thread.CurrentThread.Name & ".")
   End Sub ' Produce
End Class ' Producer

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************
