' Fig. 18.7: FrmBankUI.vb
' A reusable Windows Form for the examples in this chapter.

Public Class FrmBankUI
   ' number of TextBoxes on Form
   Protected TextBoxCount As Integer = 4

   ' enumeration constants specify TextBox indices
   Public Enum TextBoxIndices
      ACCOUNT
      FIRST
      LAST
      BALANCE
   End Enum ' TextBoxIndices

   ' clear all TextBoxes
   Public Sub ClearTextBoxes()
      ' iterate through every Control on form
      For i As Integer = 0 To Controls.Count - 1
         Dim myControl As Control = Controls(i) ' get control
         ' determine whether Control is TextBox
         If TypeOf myControl Is TextBox Then
            ' clear Text property (set to empty string)
            myControl.Text = ""
         End If
      Next i
   End Sub ' ClearTextBoxes

   ' set text box values to string array values
   Public Sub SetTextBoxValues(ByVal values() As String)
      ' determine whether string array has correct length
      If values.Length <> TextBoxCount Then
         ' throw exception if not correct length
         Throw New ArgumentException( _
            "There must be " & (TextBoxCount + 1) & _
            " strings in the array")
         ' set array values if array has correct length
      Else
         ' set array values to text box values
         txtAccount.Text = _
            values(Convert.ToInt32(TextBoxIndices.ACCOUNT))
         txtFirstName.Text = _
            values(Convert.ToInt32(TextBoxIndices.FIRST))
         txtLastName.Text = _
            values(Convert.ToInt32(TextBoxIndices.LAST))
         txtBalance.Text = _
            values(Convert.ToInt32(TextBoxIndices.BALANCE))
      End If
   End Sub ' SetTextBoxValues

   ' return text box values as string array
   Public Function GetTextBoxValues() As String()
      Dim values(TextBoxCount) As String

      ' copy text box fields to string array
      values(Convert.ToInt32(TextBoxIndices.ACCOUNT)) = _
         txtAccount.Text
      values(Convert.ToInt32(TextBoxIndices.FIRST)) = _
         txtFirstName.Text
      values(Convert.ToInt32(TextBoxIndices.LAST)) = _
         txtLastName.Text
      values(Convert.ToInt32(TextBoxIndices.BALANCE)) = _
         txtBalance.Text

      Return values
   End Function ' GetTextBoxValues
End Class ' FrmBankUI

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************