' Fig 18.5: FrmFileTest.vb
' Using classes File and Directory.
Imports System.IO

' displays contents of files and directories
Public Class FrmFileTest
   '  invoked when user presses key
   Private Sub txtInput_KeyDown(ByVal sender As System.Object, _
      ByVal e As System.Windows.Forms.KeyEventArgs) _
      Handles txtInput.KeyDown
      ' determine whether user pressed Enter key
      If e.KeyCode = Keys.Enter Then
         Dim fileName As String ' name of file or directory

         ' get user-specified file or directory
         fileName = txtInput.Text

         ' determine whether fileName is a file
         If File.Exists(fileName) Then
            ' get file's creation date, 
            ' modification date, etc.
            txtOutput.Text = GetInformation(fileName)

            ' display file contents through StreamReader
            Try
               ' obtain reader and file contents
               Dim stream As New StreamReader(fileName)
               txtOutput.Text &= stream.ReadToEnd()
               ' handle exception if StreamReader is unavailable
            Catch ex As System.IO.IOException
               MessageBox.Show("Error reading from file", "File Error", _
                  MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
            ' determine whether fileName is a directory
         ElseIf Directory.Exists(fileName) Then
            Dim directoryList() As String ' array for directories

            ' get directory's creation date, 
            ' modification date, etc.
            txtOutput.Text = GetInformation(fileName)

            ' obtain file/directory list of specified directory
            directoryList = Directory.GetDirectories(fileName)

            txtOutput.Text &= vbCrLf & vbCrLf & _
               "Directory contents:" & vbCrLf

            ' output directoryList contents
            For Each directoryName As String In directoryList
               txtOutput.Text &= directoryName & vbCrLf
            Next
         Else
            ' notify user that neither file nor directory exists
            MessageBox.Show(txtInput.Text & " does not exist", _
               "File Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
         End If
      End If
   End Sub ' txtInput_KeyDown

   ' get information on file or directory
   Private Function GetInformation(ByVal fileName As String) As String
      Dim information As String

      ' output that file or directory exists
      information = fileName & " exists" & vbCrLf & vbCrLf

      ' output when file or directory was created
      information &= "Created: " & _
         File.GetCreationTime(fileName) & vbCrLf

      ' output when file or directory was last modified
      information &= "Last modified: " & _
         File.GetLastWriteTime(fileName) & vbCrLf

      ' output when file or directory was last accessed
      information &= "Last accessed: " & _
         File.GetLastAccessTime(fileName) & vbCrLf & vbCrLf

      Return information
   End Function ' GetInformation
End Class ' FrmFileTest


'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************