' Fig. 19.22: FrmXmlReaderTest.vb
' Reading an XML document.
Imports System.Xml

Public Class FrmXmlReaderTest
   ' read XML document and display its content
   Private Sub FrmXmlReaderTest_Load(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load
      ' create the XmlReader object
      Dim settings As New XmlReaderSettings()
      Dim reader As XmlReader = XmlReader.Create("article.xml", settings)

      Dim depth As Integer = -1 ' tree depth is -1, no indentation

      While reader.Read() ' display each node's content
         Select Case (reader.NodeType)
            Case XmlNodeType.Element ' XML Element, display its name
               depth += 1 ' increase tab depth
               TabOutput(depth) ' insert tabs
               txtOutput.Text &= "<" & reader.Name & ">" & vbCrLf

               ' if empty element, decrease depth
               If reader.IsEmptyElement Then
                  depth -= 1
               End If
            Case XmlNodeType.Comment ' XML Comment, display it
               TabOutput(depth) ' insert tabs
               txtOutput.Text &= "<!--" & reader.Value & "-->" & vbCrLf
            Case XmlNodeType.Text ' XML Text, display it
               TabOutput(depth) ' insert tabs
               txtOutput.Text &= vbTab & reader.Value & vbCrLf
            Case XmlNodeType.XmlDeclaration ' XML Declaration, display it
               TabOutput(depth) ' insert tabs
               txtOutput.Text &= "<?" & reader.Name & " " & _
                  reader.Value & "?>" & vbCrLf
            Case XmlNodeType.EndElement ' XML EndElement, display it
               TabOutput(depth) ' insert tabs
               txtOutput.Text &= "</" & reader.Name & ">" & vbCrLf
               depth -= 1 ' decrement depth
         End Select
      End While
   End Sub ' FrmXmlReaderTest_Load

   ' insert tabs
   Private Sub TabOutput(ByVal number As Integer)
      For i As Integer = 1 To number
         txtOutput.Text &= vbTab
      Next
   End Sub ' TabOutput
End Class ' FrmXmlReaderTest

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************