' Fig. 20.43: FrmDisplayQueryResult.vb
' Displays the result of a user-selected query in a DataGridView.
Public Class FrmDisplayQueryResult
   ' Click event handler for the Save Button in the 
   ' BindingNavigator saves the changes made to the data
   Private Sub TitlesBindingNavigatorSaveItem_Click( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles TitlesBindingNavigatorSaveItem.Click

      Me.Validate()
      Me.TitlesBindingSource.EndEdit()
      Me.TitlesTableAdapter.Update(Me.BooksDataSet.Titles)
   End Sub ' TitlesBindingNavigatorSaveItem_Click

   ' loads data into the BooksDataSet.Titles table, 
   ' which is then displayed in the DataGridView
   Private Sub FrmDisplayQueryResult_Load(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load
      ' TODO: This line of code loads data into the 'BooksDataSet.Titles' 
      ' table. You can move, or remove it, as needed.
      Me.TitlesTableAdapter.Fill(Me.BooksDataSet.Titles)

      ' set the ComboBox to show the default query that
      ' selects all books from the Titles table
      cboQueries.SelectedIndex = 0
   End Sub ' FrmDisplayQueryResult_Load

   ' loads data into the BooksDataSet.Titles table based on
   ' user-selected query
   Private Sub cboQueries_SelectedIndexChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles cboQueries.SelectedIndexChanged
      ' fill the Titles DataTable with the result of the selected query
      Select Case cboQueries.SelectedIndex
         Case 0
            TitlesTableAdapter.Fill(BooksDataSet.Titles)
         Case 1 ' books with copyright year 2006
            TitlesTableAdapter.FillWithCopyright2006(BooksDataSet.Titles)
         Case 2 ' How to Program books, sorted by Title
            TitlesTableAdapter.FillWithHowToProgramBooks( _
               BooksDataSet.Titles)
      End Select
   End Sub ' cboQueries_SelectedIndexChanged
End Class ' FrmDisplayQueryResult


'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************
