' Fig. 23.8: FrmBrowser.vb
' WebBrowser class example.

Public Class FrmBrowser
   ' navigate back one page
   Private Sub btnBack_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnBack.Click

      webBrowser.GoBack()
   End Sub ' btnBack_Click

   ' navigate forward one page
   Private Sub btnForward_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnForward.Click

      webBrowser.GoForward()
   End Sub ' btnForward_Click

   ' stop loading the current page
   Private Sub btnStop_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnStop.Click

      webBrowser.Stop()
   End Sub ' btnStop_Click

   ' reload the current page
   Private Sub btnReload_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnReload.Click

      webBrowser.Refresh()
   End Sub ' btnReload_Click

   ' navigate to the user's home page
   Private Sub btnHome_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnHome.Click

      webBrowser.GoHome()
   End Sub ' btnHome_Click

   ' if the user pressed enter, navigate to the specified URL
   Private Sub txtNavigation_KeyDown(ByVal sender As System.Object, _
      ByVal e As System.Windows.Forms.KeyEventArgs) _
      Handles txtNavigation.KeyDown

      If e.KeyCode = Keys.Enter Then
         webBrowser.Navigate(txtNavigation.Text)
      End If
   End Sub ' txtNavigation_KeyDown

   ' enable btnStop while the current page is loading
   Private Sub webBrowser_Navigating(ByVal sender As System.Object, _
      ByVal e As System.Windows.Forms.WebBrowserNavigatingEventArgs) _
      Handles webBrowser.Navigating

      btnStop.Enabled = True
   End Sub ' webBrowser_Navigating

   ' update the status text
   Private Sub webBrowser_StatusTextChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles webBrowser.StatusTextChanged

      txtStatus.Text = webBrowser.StatusText
   End Sub ' webBrowser_StatusTextChanged

   ' update the ProgressBar for how much of the page has been loaded 
   Private Sub webBrowser_ProgressChanged( _
      ByVal sender As System.Object, ByVal e As _
      System.Windows.Forms.WebBrowserProgressChangedEventArgs) _
      Handles webBrowser.ProgressChanged
      ' Check if e.MaximumProgress is 0 or
      ' if e.MaximumProgress is less than e.CurrentProgress
      If e.MaximumProgress <> 0 And _
         e.MaximumProgress >= e.CurrentProgress Then

         prgPage.Value = Convert.ToInt32( _
            100 * e.CurrentProgress / e.MaximumProgress)
      End If
   End Sub ' webBrowser_ProgressChanged

   ' update the web browser's controls appropriately
   Private Sub webBrowser_DocumentCompleted( _
      ByVal sender As System.Object, ByVal e As _
      System.Windows.Forms.WebBrowserDocumentCompletedEventArgs) _
      Handles webBrowser.DocumentCompleted
      ' set the text in txtNavigation to the current page's URL
      txtNavigation.Text = webBrowser.Url.ToString()

      ' enable or disable btnBack and btnForward
      btnBack.Enabled = webBrowser.CanGoBack
      btnForward.Enabled = webBrowser.CanGoForward

      ' disable btnStop
      btnStop.Enabled = False

      ' clear the prgPage
      prgPage.Value = 0
   End Sub ' webBrowser_DocumentCompleted

   ' update the title of the Browser
   Private Sub webBrowser_DocumentTitleChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles webBrowser.DocumentTitleChanged

      Me.Text = webBrowser.DocumentTitle & " - Browser"
   End Sub ' webBrowser_DocumentTitleChanged
End Class ' FrmBrowser

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************
