' Fig. 23.13: WeatherClient.vb
' Client that uses .NET remoting to retrieve a weather report.
Imports System.Collections
Imports System.Drawing
Imports System.Runtime.Remoting
Imports System.Runtime.Remoting.Channels
Imports System.Runtime.Remoting.Channels.Http
Imports Weather

Public Class FrmWeatherClient
   ' retrieve weather data
   Private Sub FrmWeatherClient_Load(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load
      ' setup HTTP channel, does not need to provide a port number
      Dim channel As New HttpChannel()
      ChannelServices.RegisterChannel(channel, False)

      ' obtain a proxy for an object that implements interface Report
      Dim info As Report = CType(RemotingServices.Connect( _
         GetType(Report), "http://localhost:50000/Report"), Report)

      ' retrieve an ArrayList of CityWeather objects
      Dim cities As ArrayList = info.Reports

      ' create array and populate it with every Label
      Dim cityLabels(43) As Label
      Dim labelCounter As Integer = 0

      Dim control As Control
      For Each control In pnlDisplay.Controls
         If TypeOf control Is Label Then
            cityLabels(labelCounter) = CType(control, Label)
            labelCounter += 1 ' increment Label counter
         End If
      Next control

      ' create Hashtable and populate with all weather conditions
      Dim weather As New Hashtable()
      weather.Add("SUNNY", "sunny")
      weather.Add("PTCLDY", "pcloudy")
      weather.Add("CLOUDY", "mcloudy")
      weather.Add("MOCLDY", "mcloudy")
      weather.Add("VRYCLD", "mcloudy")
      weather.Add("TSTRMS", "rain")
      weather.Add("RAIN", "rain")
      weather.Add("FZRAIN", "rain")
      weather.Add("SNOW", "snow")
      weather.Add("VRYHOT", "vryhot")
      weather.Add("FAIR", "fair")
      weather.Add("RNSNOW", "rnsnow")
      weather.Add("SHWRS", "showers")
      weather.Add("WINDY", "windy")
      weather.Add("NOINFO", "noinfo")
      weather.Add("MISG", "noinfo")
      weather.Add("DRZL", "rain")
      weather.Add("HAZE", "noinfo")
      weather.Add("SMOKE", "mcloudy")
      weather.Add("SNOSHW", "snow")
      weather.Add("FLRRYS", "snow")
      weather.Add("FOG", "noinfo")

      ' create the font for the text output                   
      Dim font As New Font("Courier New", 8, FontStyle.Bold)

      ' for every city
      For i As Integer = 0 To cities.Count - 1
         ' use array cityLabels to find the next Label
         Dim currentCity As Label = cityLabels(i)

         ' use ArrayList cities to find the next CityWeather object
         Dim city As CityWeather = CType(cities(i), CityWeather)

         ' set current Label's image to image                          
         ' corresponding to the city's weather condition -             
         ' find correct image name in Hashtable weather
         currentCity.Image = New Bitmap("images\" & _
            weather(city.Description.Trim()).ToString() & ".png")
         currentCity.Font = font ' set font of Label                  
         currentCity.ForeColor = Color.White ' set text color of Label

         ' set Label's text to city name and temperature              
         currentCity.Text = _
            vbCrLf & " " & city.CityName & city.Temperature
      Next
   End Sub ' FrmWeatherClient_Load
End Class ' FrmWeatherClient

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************