' Fig. 26.7: HashtableTest.vb
' Application counts the number of occurrences of each word in a String
' and stores them in a hash table.
Imports System.Text.RegularExpressions
Imports System.Collections

Module HashtableTest
   Sub Main()
      ' create hash table based on user input
      Dim table As Hashtable = CollectWords()

      ' display hash table content
      DisplayHashtable(table)
   End Sub ' Main

   ' create hash table from user input
   Private Function CollectWords() As Hashtable
      Dim table As New Hashtable() ' create a new hash table

      Console.WriteLine("Enter a string: ") ' prompt for user input
      Dim input As String = Console.ReadLine() ' get input

      ' split input text into tokens
      Dim words As String() = Regex.Split(input, "\s+")

      ' processing input words
      For Each word As String In words
         Dim wordKey As String = word.ToLower() ' get word in lowercase

         ' if the hash table contains the word
         If table.ContainsKey(wordKey) Then
            table(wordKey) = Convert.ToInt32(table(wordKey)) + 1
         Else
            ' add new word with a count of 1 to hash table
            table.Add(wordKey, 1)
         End If
      Next

      Return table
   End Function ' CollectWords

   ' display hash table content
   Private Sub DisplayHashtable(ByVal table As Hashtable)
      Console.WriteLine(vbCrLf & "Hashtable contains:" & _
         vbCrLf & "{0,-12}{1,-12}", "Key:", "Value:")

      ' generate output for each key in hash table
      ' by iterating through the Keys property with a For Each statement
      For Each key As Object In table.Keys
         Console.WriteLine("{0,-12}{1,-12}", key, table(key))
      Next

      Console.WriteLine(vbCrLf & "size: {0}", table.Count)
   End Sub ' DisplayHashtable
End Module ' HashtableTest


'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************